<?

$appname = "<a href=\"http://sourceforge.net/projects/tfh-bt-tracker/\">Tin Foil Hat BitTorrent tracker</a>";
$version = "0.90";

require_once("include/general_func.inc.php");
require_once("include/error_404.inc.php");

function getmicrotime()
{ 
	list($usec, $sec) = explode(" ",microtime()); 
	return ((float)$usec + (float)$sec); 
}

$time_start = getmicrotime();

require_once("secrets.inc.php");
require_once("cleanup.php");

$max_torrent_size = 10 * 1024 * 1024;	//10MiB
$announce_interval = 3600;		//1 hour
$signup_timeout = 86400 * 14;		//14 days
$max_dead_torrent_time = 3 * 24 * 3600;	//3 day
$autoclean_interval = 600;		//10 minutes
$pic_base_url = "pic/";

##########################
#
# Changes below here should not normally be required
#
##########################

# the first one will be displayed on the pages
$announce_urls = array();
$announce_urls[] = $tracker_url . "/announce.php";

function mask_email($email)
{
	return $email;
}

function statusdesc($status)
{
        if ($status == "confirmed")
                return "has confirmed activation";
        elseif ($status == "notaccepted")
                return "is waiting for someone to accept/decline the user account";
        elseif ($status == "pending")
                return "is waiting for user to accept registration";
        elseif ($status == "rejected")
                return "request was rejected by an administrator";
        else
                return "unknown/undocumented status";
}

function showerror($error, $extrainfo = "")
{
	echo("FATAL ERROR:<br>" . $error . "<br>");
	
	echo("Requested URL: " . $_SERVER["REQUEST_URI"] . "<br>");
	
	if ($extrainfo != "" && istrusted())
		echo("<br>Extra information:<br>" . $extrainfo);

	trigger_error($error . " - '" . $extrainfo . "'", E_USER_ERROR);
	
	die();
}

function istrusted()
{
	return istrustedip($_SERVER["REMOTE_ADDR"]);
}

function istrustedip($ip)
{
	global $trustedip;
	return $ip == $trustedip;
}

//identifies bittorrent peer with the given IP address
//returns user.id
function identify_peer($ip)
{
	$res = safequery("SELECT id FROM user WHERE last_login_ip = '" . trim($ip) . "' AND status = 'confirmed' LIMIT 1");
	if ($row = mysql_fetch_array($res))
		return $row["id"];
	
	$res = safequery("SELECT user_id FROM peer WHERE ip = '".trim($ip)."' LIMIT 1");
	if ($row = mysql_fetch_array($res))
		return $row["user_id"];
	
	return null;
}

function identified_peers_only()
{
	$user_id = identify_peer($_SERVER["REMOTE_ADDR"]);
	if ($user_id == null)
	{
		error_404();
		die();
	}
	else
	{
		return $user_id;
	}
}

function dbconn($autoclean = 1)
{
	global $mysql_host, $mysql_user, $mysql_pass, $mysql_db;
	
	@mysql_pconnect($mysql_host, $mysql_user, $mysql_pass)
		or showerror(mysql_error());
	mysql_select_db($mysql_db)
		or showerror(mysql_error());
	
	userlogin();
	
	if ($autoclean)
		register_shutdown_function("autoclean");
}

function isadmin($userrow)
{
	return $userrow["admin"] == "yes";
}

function userlogin() {
	unset($GLOBALS["CURUSER"]);
	
	if (empty($_COOKIE["uid"]) || empty($_COOKIE["pass"]))
		return;
	
	$id = 0 + $_COOKIE["uid"];
	if (!$id || strlen($_COOKIE["pass"]) != 32)
		return; //usererr("Invalid cookie");
	
	$res = safequery("SELECT id, username, email, admin, passhash, secret, status FROM user WHERE id = $id AND status = 'confirmed'");
	$row = mysql_fetch_array($res);
	
	if (!$row)
		return;//usererr("User not found.");
	
	$sec = hash_pad($row["secret"]);
	
	if ($_COOKIE["pass"] !== md5($sec . $row["passhash"] . $sec))
		return;
	
	$GLOBALS["CURUSER"] = $row;
	
	safequery("UPDATE user SET last_access = NOW(), last_login_ip = '" . $_SERVER["REMOTE_ADDR"] . "' WHERE id = " . $row["id"]);
}

function autoclean()
{
	global $autoclean_interval;

	$now = time();
	$docleanup = 0;

	$res = mysql_query("SELECT value_u FROM avps WHERE arg = 'lastcleantime'");
	$row = mysql_fetch_array($res);
	if (!$row)
	{
		mysql_query("INSERT INTO avps (arg, value_u) VALUES ('lastcleantime',$now)");
		return;
	}
	$ts = $row[0];
	if ($ts + $autoclean_interval > $now)
		return;
	mysql_query("UPDATE avps SET value_u=$now WHERE arg='lastcleantime' AND value_u = $ts");
	if (!mysql_affected_rows())
		return;

	docleanup();
}

function unesc($x)
{
	if (get_magic_quotes_gpc())
		return stripslashes($x);
	return $x;
}

/*
function mksize($bytes)
{

	$suffix = array ('B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB');
	$index = floor (log ($bytes + 1, 1024)); // + 1 to prevent -INF
	return sprintf ("%.0f %s", $bytes / pow (1024, $index), $suffix[$index]);
}
*/

function mksize($size)
{
	$kb = 1024;
	$mb = 1024 * $kb;
	$gb = 1024 * $mb;
	$tb = 1024 * $gb;
      
	if ($size < $kb)
	{
		return $size . " bytes";
	}
	elseif ($size < $mb)
	{
		$size = number_format(($size / $kb),2,".","");
		return $size . " KiB";
	}
	elseif ($size < $gb)
	{
		$size = number_format(($size / $mb),2,".","");
		return $size . " MiB";
	}
	elseif ($size < $tb)
	{
		$size = number_format(($size / $gb),2,".","");
		return $size . " GiB";
        }
        else
	{
		$size = number_format(($size / $tb),2,".","");
		return $size . " TiB";
	}
} 

function deadtime() {
	global $announce_interval;
	return time() - floor($announce_interval * 1.3);
}

function mkprettytime($s) {
	if ($s < 0)
		$s = 0;
	$t = array();
	foreach (array("60:sec","60:min","24:hour","0:day") as $x) {
		$y = explode(":", $x);
		if ($y[0] > 1) {
			$v = $s % $y[0];
			$s = floor($s / $y[0]);
		}
		else
			$v = $s;
		$t[$y[1]] = $v;
	}

	if ($t["day"])
		return $t["day"] . " day(s), " . sprintf("%02d:%02d:%02d", $t["hour"], $t["min"], $t["sec"]);
	if ($t["hour"])
		return sprintf("%d:%02d:%02d", $t["hour"], $t["min"], $t["sec"]);
	if ($t["min"])
		return sprintf("%d:%02d", $t["min"], $t["sec"]);
	return $t["sec"] . " secs";
}

function mkglobal($vars) {
	if (!is_array($vars))
		$vars = explode(":", $vars);
	foreach ($vars as $v) {
		if (isset($_GET[$v]))
			$GLOBALS[$v] = unesc($_GET[$v]);
		elseif (isset($_POST[$v]))
			$GLOBALS[$v] = unesc($_POST[$v]);
		else
			return 0;
	}
	return 1;
}

function tr($x,$y,$noesc=0) {
	if ($noesc)
		$a = $y;
	else {
		$a = htmlspecialchars($y);
		$a = str_replace("\n", "<br />\n", $a);
	}
	print("<tr><td>$x</td><td>$a</td></tr>\n");
}

function validfilename($name) {
	return preg_match('/^[^\0-\x1f:\\\\\/?*\xff#<>|]+$/si', $name);
}

function validemail($email) {
	return preg_match('/^[\w.-]+@([\w.-]+\.)+[a-z]{2,6}$/is', $email);
}

function sqlesc($x) {
	return "'".mysql_real_escape_string($x)."'";
}

function sqlesc2($str)
{
	return mysql_real_escape_string($str);
}

function sqlwildcardesc($x) {
	return str_replace(array("%","_"), array("\\%","\\_"), mysql_real_escape_string($x));
}

function urlparse($m) {
	$t = $m[0];
	if (preg_match(',^\w+://,', $t))
		return "<a href=\"$t\">$t</a>";
	return "<a href=\"http://$t\">$t</a>";
}

function parsedescr($d) {
	$pd = str_replace(array("\n", "\r"), array("<br />\n", ""), htmlspecialchars($d));
	$pd = preg_replace_callback('(\w+://([^\s/:@]+(:[^\s/:@]++)?@)?|\bwww\.)[\w.-]+(:\d+)?(/[-\w=./?&%+#;|@]*)?[0-9a-z/]is', "urlparse", $pd);
	return $pd;
}

function stdhead($title = "") {
	require_once("general_func.inc.php");
	showheader($title);
	
	/*
	global $CURUSER, $pic_base_url, $tracker_title;
	header("Content-Type: text/html; charset=iso-8859-1");
	if ($title == "")
		$title = $tracker_title . " BitTracker";
	else
		$title = $tracker_title . " BitTracker - " . htmlspecialchars($title);
	$trackertitle = $title;
	include("page_header.inc.php");
	*/
}

function stdfoot()
{
	global $CURUSER;
	if (isset($CURUSER))
	{
		global $pic_base_url, $version, $appname, $time_start;
	        $time = round(getmicrotime() - $time_start,4);
		print('</td></tr><tr><td width="100%" height="21" colspan="2">');
		print('<div align="center"><font face=arial size=1>' . $appname . " v" . $version . ' -- Page generated in ' . $time . ' secs</div><br>');
		print('<center><font size="1">'.shell_exec("uptime").'</font></center>');
		print('</td></tr></table></div></body></html>');
	}
	else
	{
		echo("</td></tr></table></body></html>");
	}
}

function genbark($message,$title) {
	stdhead($title);
	print("<h2>" . $title . "</h2>\n");
	print("<p>" . $message . "</p>\n");
	stdfoot();
	exit();
}

function mksecret($len = 20) {
	$ret = "";
	for ($i = 0; $i < $len; $i++)
		$ret .= chr(mt_rand(0, 255));
	return $ret;
}

function httperr($code = 404, $message = "") {
	header("HTTP/1.0 404 Not found");
	if ($message == "")
	{
		print("<h1>Not Found</h1>\n");
		print("<p>Sorry pal :(</p>\n");
	}
	else
	{
		echo($message);
	}
	exit();
}

function logincookie($id, $passhash, $secret, $updatedb = 1) {
	$md5 = md5($secret . $passhash . $secret);
	
	setcookie("uid", $id, 0x7fffffff, "/");
	setcookie("pass", $md5, 0x7fffffff, "/");
	
	if ($updatedb)
	{
		$ip = $_SERVER["REMOTE_ADDR"];
		safequery("UPDATE user SET last_login = NOW(), last_login_ip = '$ip' WHERE id = $id");
	}
}

function logoutcookie() {
	setcookie("uid", "", 0x7fffffff, "/");
	setcookie("pass", "", 0x7fffffff, "/");
}

function loggedinorreturn()
{
	loggedonly();
}

function currentadmin()
{
	global $CURUSER;
	return isadmin($CURUSER);
}

function adminonly()
{
	global $CURUSER;
	if (!isset($CURUSER))
	{
		echo 'Not logged in';
		returnto("login.php?returnto=" . urlencode($_SERVER["REQUEST_URI"]));
		exit();
	}
	
	if (!isadmin($CURUSER))
	{
		genbark("The page you tried to access is available for server administrators only", "Admins only");
		exit();
	}
}

/*	FUNCTION WAS MOVED TO core_func.inc.php
	AND WAS RENAMED TO delete_torrent
function deletetorrent($id)
{
	global $torrent_dir;
	safequery("DELETE FROM torrent WHERE id = $id");
	safequery("DELETE FROM peer WHERE torrent = $id");
	safequery("DELETE FROM comment WHERE torrent = $id");
	safequery("DELETE FROM file WHERE torrent = $id");
	unlink("$torrent_dir/$id.torrent");
}
*/

function pager($rpp, $count, $href, $opts = array()) {
	$pages = ceil($count / $rpp);

	if (!@$opts["lastpagedefault"])
		$pagedefault = 0;
	else {
		$pagedefault = floor(($count - 1) / $rpp);
		if ($pagedefault < 0)
			$pagedefault = 0;
	}

	if (isset($_GET["page"])) {
		$page = 0 + $_GET["page"];
		if ($page < 0)
			$page = $pagedefault;
	}
	else
		$page = $pagedefault;

	$pager = "";

	$mp = $pages - 1;
	$as = "<b>&lt;&lt;&nbsp;Prev</b>";
	if ($page >= 1) {
		$pager .= "<a href=\"{$href}page=" . ($page - 1) . "\">";
		$pager .= $as;
		$pager .= "</a>";
	}
	else
		$pager .= $as;
	$pager .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
	$as = "<b>Next&nbsp;&gt;&gt;</b>";
	if ($page < $mp && $mp >= 0) {
		$pager .= "<a href=\"{$href}page=" . ($page + 1) . "\">";
		$pager .= $as;
		$pager .= "</a>";
	}
	else
		$pager .= $as;

	if ($count) {
		$pagerarr = array();
		$dotted = 0;
		$dotspace = 3;
		$dotend = $pages - $dotspace;
		$curdotend = $page - $dotspace;
		$curdotstart = $page + $dotspace;
		for ($i = 0; $i < $pages; $i++) {
			if (($i >= $dotspace && $i <= $curdotend) || ($i >= $curdotstart && $i < $dotend)) {
				if (!$dotted)
					$pagerarr[] = "...";
				$dotted = 1;
				continue;
			}
			$dotted = 0;
			$start = $i * $rpp + 1;
			$end = $start + $rpp - 1;
			if ($end > $count)
				$end = $count;
			$text = "$start&nbsp;-&nbsp;$end";
			if ($i != $page)
				$pagerarr[] = "<a href=\"{$href}page=$i\">$text</a>";
			else
				$pagerarr[] = "<b>$text</b>";
		}
		$pagerstr = join(" | ", $pagerarr);
		$pagertop = "<p align=\"center\">$pager<br />$pagerstr</p>\n";
		$pagerbottom = "<p align=\"center\">$pagerstr<br />$pager</p>\n";
	}
	else {
		$pagertop = "<p align=\"center\">$pager</p>\n";
		$pagerbottom = $pagertop;
	}

	$start = $page * $rpp;

	return array($pagertop, $pagerbottom, "LIMIT $start,$rpp");
}

function downloaderdata($res) {
	$rows = array();
	$ids = array();
	$peerdata = array();
	while ($row = mysql_fetch_assoc($res)) {
		$rows[] = $row;
		$id = $row["id"];
		$ids[] = $id;
		$peerdata[$id] = array(downloaders => 0, seeders => 0, comments => 0);
	}

	if (count($ids)) {
		$allids = implode(",", $ids);
		$res = mysql_query("SELECT COUNT(*) AS c, torrent, seeder FROM peers WHERE torrent IN ($allids) GROUP BY torrent, seeder");
		while ($row = mysql_fetch_assoc($res)) {
			if ($row["seeder"] == "yes")
				$key = "seeders";
			else
				$key = "downloaders";
			$peerdata[$row["torrent"]][$key] = $row["c"];
		}
		$res = mysql_query("SELECT COUNT(*) AS c, torrent FROM comments WHERE torrent IN ($allids) GROUP BY torrent");
		while ($row = mysql_fetch_assoc($res)) {
			$peerdata[$row["torrent"]]["comments"] = $row["c"];
		}
	}

	return array($rows, $peerdata);
}

function commenttable($rows) {
	print("<table class=\"table2\" align=\"center\" cellspacing=\"0\" width=\"75%\" cellpadding=\"1\">\n");
	$count = 0;
	foreach ($rows as $row) {
		print("<tr>\n");
		echo("<td>" . userlink($row["id"], $row["username"]) . "</td>");
		/*
		if (isset($row["username"]))
			print("<td class=\"td1\"><a name=\"comm" . $row["id"] . "\">" . htmlspecialchars($row["username"]) . "</a></td>\n");
		else
			print("<td class=\"td1\"><a name=\"comm" . $row["id"] . "\"><i>(orphaned)</i></a></td>\n");
		*/
		print("<td class=\"td1\" align=\"right\">" . htmlspecialchars($row["added"]) . "</td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print("<td colspan=\"2\">" . $row["text"] . "</td>\n");
		print("</tr>\n");
		$count++;
	}
	print("</table>");
}

function searchfield($s)
{
	return preg_replace(array('/[^a-z0-9]/si', '/^\s*/s', '/\s*$/s', '/\s+/s'), array(" ", "", "", " "), $s);
}

//completes categories with main categories
//takes in an array of category.id
//ie:
//psytrance would output music, trance, psytrance
//returns an array of integers

function complete_categories($arr)
{
	$ret = array();
	//debug_array($arr, "arr");
	foreach($arr as $item)
	{
		if (is_array($item))
			$category_id = $item["id"];
		else
			$category_id = $item;
		
		/*
		if (intval($category_id) < 1)
			die("complete_categories(): category_id = $category_id");
		*/
		
		$owners = get_category_owners($category_id);
		//debug_array($owners, "Owners1");
		
		$owners = array_reverse($owners);
		//debug_array($owners, "Owners2");
		
		foreach($owners as $row2)
		{
			/*
			echo "row2 = " . $row2 . "<br>";
			echo "row2[0] = " . $row2[0] . "<br>";
			*/
			$row2_id = $row2["id"];
			/*
			if (intval($row2_id) < 1)
				die("complete_categories(): row2_id = $row2_id");
			*/
			
			$ret[] = $row2_id;
		}
		$ret[] = $category_id;
	}
	return array_unique($ret);
}

function debug_array($arr, $name)
{
	echo "$name = ";
	print_r($arr);
	echo "<br>";
}

function add_categories($cats, $torrent_id)
{
	safequery("DELETE FROM torrent_category WHERE torrent_id = $torrent_id");
	
	foreach($cats as $item)
	{
		if (is_array($item))
			$category_id = $item["id"];
		else
			$category_id = $item;
		
		safequery("INSERT INTO torrent_category (torrent_id, category_id) VALUES (" . $torrent_id . ", " . $category_id . ")");
	}
}

//checks categories for invalid values
//returns string on error
//returns "" if okay
function check_categories($arr)
{
	if (count($arr) < 1)
		return "Choose at least one category, preferably as many the torrent fits in. You can have multiple subcategories but only one main (root) category.";
	
	$main_count = 0;
	foreach ($arr as $item)
	{
		if (is_array($item))
			$category_id = $item["id"];
		else
			$category_id = $item;
		
		if (intval($category_id) < 1)
			die("check_categories(): category_id = $category_id, item = $item");
		
		if (is_main_category($category_id))
			$main_count++;
	}
	
	if ($main_count > 1)
		return "Category selection contains more than one ($main_count) main category. Only one main category per torrent is allowed. Read the FAQ for more information.";
	else
		return "";
}

//unnecessary?
/*
//chooses the main category from given array
//returns category.id
function choose_main_category($arr)
{
	foreach ($arr as $item)
	{
		if (is_array($item))
			$category_id = $item["id"];
		else
			$category_id = $item;
		
		if (intval($category_id) < 1)
			die("choose_main_category(): invalid category_id '$category_id'");

		if (is_main_category($category_id))
			return $category_id;
	}
	showerror("Main category not found from array?");
}
*/

function is_main_category($category_id)
{
	if (intval($category_id) < 1)
		die("is_main_category(): invalid category_id '$category_id'");
	
	$res = safequery("SELECT COUNT(*) FROM category WHERE id = $category_id AND owner_id IS NULL");
	$row = mysql_fetch_array($res);
	return $row[0] == 1;
}

function create_categorylist($filename, $terms = "category.is_abstract = 0")
{
	$res = safequery("SELECT id,owner_id,name,fullname FROM category WHERE $terms ORDER BY sort_index, id");
	$fp = fopen($filename, "w") or die("can't open file $filename for write access");
	while ($row = mysql_fetch_array($res))
	{
		$fullname = create_category_fullname($row);
		
		//<option value="none">Choose type</option>
		
		fputs($fp, "<option value=\"" . $row["id"] . "\">". htmlspecialchars($fullname). "</option>\r\n") or die("cannot write to file $filename");
	}
	fclose($fp);
}

function update_category_fullnames()
{
	$res = safequery("SELECT id,owner_id,name,fullname FROM category");
        while ($row = mysql_fetch_array($res))
        {
		$fullname = create_category_fullname($row);
		
		//<option value="none">Choose type</option>
		safequery("UPDATE category SET fullname = '" . sqlesc2($fullname) . "' WHERE id = " . $row["id"] . " LIMIT 1");
        }
}


//returns array with arrays as values
function get_category_owners($category_id)
{
	$res = safequery("SELECT b_category.id AS id, b_category.name AS name, b_category.owner_id AS owner_id FROM category LEFT JOIN category AS b_category ON category.owner_id = b_category.id WHERE category.id = $category_id AND b_category.id IS NOT NULL LIMIT 1");
	if ($row = mysql_fetch_array($res))
	{
		$ret = array($row);
		if ($row["owner_id"] != null)
		{
			$idnow = $row["id"];
			$owners = get_category_owners($idnow);
			foreach ($owners as $row2)
				$ret[] = $row2;
		}
		//debug_array($ret, "get_category_owners() returning");
		return $ret;
	}
	else
	{
		return array();
	}
}

//creates string of category owners and the category name itself
function create_category_fullname($row)
{
	$owners = "";
	if ($row["owner_id"] != null)
	{
		$arr = get_category_owners($row["id"]);
		foreach (array_reverse($arr) as $row2)
		{
			if ($owners != "")
				$owners .= " - ";
			
			$owners .= $row2["name"];
		}
	}
	
	if ($owners != "")
		$owners .= " - ";
	
	return $owners . $row["name"];
}

/*
function genrelist()
{
	$ret = array();
	$res = safequery("SELECT id, name FROM category WHERE owner_id IS NULL ORDER BY sort_index, id");
	while ($row = mysql_fetch_array($res))
		$ret[] = $row;
	return $ret;
}
*/

function linkcolor($num) {
	if (!$num)
		return "red";
	if ($num == 1)
		return "yellow";
	return "green";
}

function torrenttable($res, $variant = "index") {
	global $pic_base_url;
?>
<table align=center cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="95%" class="table1">
<td>
<table align=center cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" border="1" class="table1">
<tr>

<td align=center class="td1"><span class="text1">Type</span></td>
<td align=center class="td1"><span class="text1">Name</span></td>
<td align=center class="td1"><span class="text1">&nbsp;</span></td>
<?

	if ($variant == "mytorrents")
		print("<td align=center class=\"td1\"><span class=\"text1\">Visible</span></td>\n");

?>
<td align=center class="td1"><span class="text1">Files</span></td>
<td align=center class="td1"><span class="text1">Comments</span></td>
<td align=center class="td1"><span class="text1">Added</span></td>
<td align=center class="td1"><span class="text1">Size</span></td>
<td align=center class="td1"><span class="text1">Views</span></td>
<td align=center class="td1"><span class="text1">Hits</span></td>
<td align=center class="td1"><span class="text1">Downloads</span></td>
<td align=center class="td1"><span class="text1">Seeds</span></td>
<td align=center class="td1"><span class="text1">Leeches</span></td>
<td align=center class="td1"><span class="text1">Uploader</span></td>

<?

	print("</tr>\n");

	while ($row = mysql_fetch_assoc($res)) {
		$id = $row["id"];
		print("<tr>\n");

		print("<td class=\"r2\" align=center>");
		if (isset($row["cat_name"])) {
			print("<a href=\"./?cat=" . $row["category"] . "\">" . $row["cat_name"] . "</a>");
		}
		else
			print("-");
		print("</td>\n");

		$dispname = "<b>" . htmlspecialchars($row["name"]) . "</b>";
		print("<td class=\"r1\" align=center><font size=2><a href=\"details.php?");
		if ($variant == "mytorrents")
			print("returnto=" . urlencode($_SERVER["REQUEST_URI"]) . "&amp;");
		print("id=$id");
		if ($variant == "index")
			print("&amp;hit=1");
		print("\">$dispname</a></td>\n");

		if ($variant == "index") {
			print("<td class=\"r2\" align=center><a href=\"download.php?id=$id&file=" . htmlentities(urlencode($row["filename"])) . "\">");
			print("<img src=\"" . $pic_base_url . "dl.gif\" border=0></a></td>");
		} elseif ($variant == "mytorrents")
			print("<td class=\"r2\" align=center><a href=\"edit.php?returnto=" . urlencode($_SERVER["REQUEST_URI"]) . "&amp;id=" . $row["id"] . "\">edit</a></td>\n");

		if ($variant == "mytorrents") {
			print("<td class=\"r1\" align=center>");
			if ($row["visible"] == "no")
				print("<b>no</b>");
			else
				print("yes");
			print("</td>\n");
		}

		if ($row["type"] == "single")
			print("<td class=\"r2\" align=center><font size=2 face=arial>" . $row["numfiles"] . "</td>\n");
		else {
			if ($variant == "index")
				print("<td class=\"r2\" align=center><b><font size=2 face=arial><a href=\"details.php?id=$id&amp;hit=1&amp;filelist=1\">" . $row["numfiles"] . "</a></b></td>\n");
			else
				print("<td class=\"r2\" align=center><b><font size=2 face=arial><a href=\"details.php?id=$id&amp;filelist=1#filelist\">" . $row["numfiles"] . "</a></b></td>\n");
		}

		if (!$row["comments"])
			print("<td class=\"r1\" align=center><font size=2 face=arial>" . $row["comments"] . "</td>\n");
		else {
			if ($variant == "index")
				print("<td class=\"r1\" align=center><b><font size=2 face=arial><a href=\"details.php?id=$id&amp;hit=1&amp;tocomm=1\">" . $row["comments"] . "</a></b></td>\n");
			else
				print("<td class=\"r1\" align=center><b><font size=2 face=arial><a href=\"details.php?id=$id&amp;page=0#startcomments\">" . $row["comments"] . "</a></b></td>\n");
		}

		print("<td class=\"r1\" align=center><font size=2 face=arial>" . str_replace(" ", "<br />", $row["added"]) . "</td>\n");
		print("<td class=\"r2\" align=right><font size=2 face=arial>" . mksize($row["size"]) . "</td>\n");
		print("<td class=\"r1\" align=center><font size=2 face=arial>" . $row["views"] . "</td>\n");
		print("<td class=\"r2\" align=center><font size=2 face=arial>" . $row["hits"] . "</td>\n");
		print("<td class=\"r1\" align=center><font size=2 face=arial>" . $row["times_completed"] . "</td>\n");

		if ($row["seeders"]) {
			if ($variant == "index")
				print("<td class=\"r2\" align=center><b><font size=2 face=arial><a class=\"" . linkcolor($row["seeders"]) . "\" href=\"details.php?id=$id&amp;hit=1&amp;toseeders=1\">" . $row["seeders"] . "</a></b></td>\n");
			else
				print("<td class=\"r2\" align=center><b><font size=2 face=arial><a class=\"" . linkcolor($row["seeders"]) . "\" href=\"details.php?id=$id&amp;dllist=1#seeds\">" . $row["seeders"] . "</a></b></td>\n");
		}
		else
			print("<td class=\"r2\" align=center><font size=2 face=arial><span class=\"" . linkcolor($row["seeders"]) . "\">" . $row["seeders"] . "</span></td>\n");

		if ($row["leechers"]) {
			if ($variant == "index")
				print("<td class=\"r1\" align=center><font size=2 face=arial><b><a class=\"" . linkcolor($row["leechers"]) . "\" href=\"details.php?id=$id&amp;hit=1&amp;todlers=1\">" . $row["leechers"] . "</a></b></td>\n");
			else
				print("<td class=\"r1\" align=center><font size=2 face=arial><b><a class=\"" . linkcolor($row["leechers"]) . "\" href=\"details.php?id=$id&amp;dllist=1#leeches\">" . $row["leechers"] . "</a></b></td>\n");
		}
		else
			print("<td class=\"r1\" align=center><font size=2 face=arial><span class=\"" . linkcolor($row["leechers"]) . "\">" . $row["leechers"] . "</span></td>\n");

		if ($variant == "index")
			print("<td class=\"r2\" align=right><font size=2 face=arial>" . (isset($row["username"]) ? htmlspecialchars($row["username"]) : "<i>(unknown)</i>") . "</td>\n");

		print("</tr>\n");
	}

	print("</table></td></table>\n");

	if (isset($rows))
		return $rows;
}

function hash_pad($hash) {
	return str_pad($hash, 20);
}

function hash_where($name, $hash) {
	$shhash = preg_replace('/ *$/s', "", $hash);
	return "($name = " . sqlesc($hash) . " OR $name = " . sqlesc($shhash) . ")";
}

function delete_user($id)
{
	$res = safequery("SELECT admin FROM user WHERE id = $id");
	$row = mysql_fetch_array($res);
	if (isadmin($row[0]))
		die("You have no permissions to this user");
	
	safequery("UPDATE user SET deleted = 1 WHERE id = $id");
}

?>
