<?
require_once("include/benc.php");
require_once("include/bittorrent.inc.php");

dbconn(); 

loggedinorreturn();

ini_set("upload_max_filesize",$max_torrent_size);

function bark($msg)
{
	usererr("Upload failed!", $msg, "upload.php");
}

if (!isset($_POST["descr"]))
	bark("Missing description");

if (!isset($_FILES["file"]))
	bark("Missing file");

$cats = array();
for ($k=1; $k<=9; $k++)
{
	if (isset($_POST["category" . $k]))
	{
		$cat = intval($_POST["category" . $k]);
		if ($cat > 0)
			$cats[] = $cat;
		else if ($cat < 0)
			bark("Invalid category " . $_POST["category" . $k]);
	}
}

$cats = complete_categories($cats);

$cat_err = check_categories($cats);
if ($cat_err != "")
	bark("Error in category selections: " . $cat_err);

/*
$category_id = choose_main_category($cats); //main (root) category that is show in lists
*/

$f = $_FILES["file"];
$fname = unesc($f["name"]);

if (empty($fname))
	bark("Empty filename!");

if (!validfilename($fname))
	bark("Invalid filename!");

if (!preg_match('/^(.+)\.torrent$/si', $fname, $matches))
	bark("Filename not a .torrent");

$shortfname = $torrent = $matches[1];

function create_torrent_name($filename)
{
	$tmp = str_replace("_", " ", $filename);
	$tmp = substr($tmp, strlen($tmp) - strlen(".torrent"));
	return $tmp;
}

if (!empty($_POST["name"]))
	$torrent = unesc($_POST["name"]);

$tmpname = $f["tmp_name"];
if (!is_uploaded_file($tmpname))
	bark("eek");

if (!filesize($tmpname))
	bark("Empty file!");

$dict = bdec_file($tmpname, $max_torrent_size);

if (!isset($dict))
	bark("What the hell did you upload? This is not a bencoded file!");

function dict_check($d, $s)
{
	if ($d["type"] != "dictionary")
		bark("not a dictionary");
	$a = explode(":", $s);
	$dd = $d["value"];
	$ret = array();
	foreach ($a as $k) {
		unset($t);
		if (preg_match('/^(.*)\((.*)\)$/', $k, $m)) {
			$k = $m[1];
			$t = $m[2];
		}
		if (!isset($dd[$k]))
			bark("dictionary is missing key(s)");
		if (isset($t)) {
			if ($dd[$k]["type"] != $t)
				bark("invalid entry in dictionary");
			$ret[] = $dd[$k]["value"];
		}
		else
			$ret[] = $dd[$k];
	}
	return $ret;
}

function dict_get($d, $k, $t)
{
	if ($d["type"] != "dictionary")
		bark("not a dictionary");
	$dd = $d["value"];
	if (!isset($dd[$k]))
		return;
	$v = $dd[$k];
	if ($v["type"] != $t)
		bark("invalid dictionary entry type");
	return $v["value"];
}

list($ann, $info) = dict_check($dict, "announce(string):info");
list($dname, $plen, $pieces) = dict_check($info, "name(string):piece length(integer):pieces(string)");

if (!in_array($ann, $announce_urls, 1))
	bark("Invalid announce url in torrent! Must be <b>" . $announce_urls[0] . "</b>");

if (strlen($pieces) % 20 != 0)
	bark("invalid pieces");

$filelist = array();
$totallen = dict_get($info, "length", "integer");
if (isset($totallen)) {
	$filelist[] = array($dname, $totallen);
	$type = "single";
}
else {
	$flist = dict_get($info, "files", "list");
	if (!isset($flist))
		bark("missing both length and files");
	if (!count($flist))
		bark("no files");
	$totallen = 0;
	foreach ($flist as $fn) {
		list($ll, $ff) = dict_check($fn, "length(integer):path(list)");
		$totallen += $ll;
		$ffa = array();
		foreach ($ff as $ffe) {
			if ($ffe["type"] != "string")
				bark("filename error");
			$ffa[] = $ffe["value"];
		}
		if (!count($ffa))
			bark("filename error");
		$ffe = implode("/", $ffa);
		$filelist[] = array($ffe, $ll);
	}
	$type = "multi";
}

$infohash = pack("H*", sha1($info["string"]));

$descr = unesc($_POST["descr"]);

safequery("INSERT INTO torrent".
	" (search_text, filename, owner, visible, info_hash, name, size, numfiles, type, descr, ori_descr, save_as, added, last_action)".
	" VALUES (" .
		implode(",", array_map("sqlesc", array(searchfield("$shortfname $dname $torrent"), $fname, $CURUSER["id"], "no", $infohash, $torrent, $totallen, count($filelist), $type, parse_comment($descr), $descr, $dname))) .
		", NOW(), NOW())");
$id = mysql_insert_id();

add_categories($cats, $id);

safequery("DELETE FROM file WHERE torrent = $id");

foreach ($filelist as $file)
{
	safequery("INSERT INTO file (torrent, filename, size) VALUES ($id, ".sqlesc($file[0]).",".$file[1].")");
}

move_uploaded_file($tmpname, "$torrent_dir/$id.torrent");

//returnto("details.php?id=$id");
confirmation("Torrent was successfully uploaded. Torrent won't be visible until it has at least one seed!", "details.php?id=$id", "Torrent uploaded", 5);
?>
