<?
require_once('include/bittorrent.inc.php');
require_once('include/general_func.inc.php');

dbconn();

loggedinorreturn();

stdhead("Submit an upload request (alpha)");

$tried_submit = false;	//true if the user tried to submit the request

if (isset($_POST["name"]))
{
	$name = trim($_POST["name"]);
	$tried_submit = true;
	if (strlen($name) < 5)
		page_err("Upload request name (title) must be at least 5 chars long");
}
else
	$name = "";

if (isset($_POST["description"]))
	$description = trim($_POST["description"]);
else
	$description = "";

$max_categories = 3;

$categories = parse_categories($_POST, $max_categories);
if ($tried_submit)
{
	if (count($categories) < 1)
		page_err("Must have at least one category");
}

global $err_count;
if ($tried_submit && $err_count == 0)
{
	//uploadrequest accepted, this far, doing final checks
	$count = safequery_scalar("SELECT COUNT(*) FROM uploadrequest WHERE name = " . sqlesc(trim($name)));
	
	/*
	id 			int(10) 	 	UNSIGNED	Ei 	 	auto_increment 	 	 	 	 	 	 	
 	name 			varchar(30)	latin1_swedish_ci	 	Ei 	 	 	 	 	 	 	 	 	
 	description 		text	latin1_swedish_ci	 	Ei 	 	 	 	 	 	 	 	 	
 	user_id 		int(10) 	 	UNSIGNED	Ei 	0 	 	 	 	 	 	 	 	
 	matching_torrents 	int(10) 	 	UNSIGNED	Ei 	0 	 	 	 	 	 	 	 	
 	status			enum('bad', 'ok', 'good')	latin1_swedish_ci	 	Ei 	bad 	 	 	 	 	 	 	 	
 	deleted 		tinyint(1) 	 	UNSIGNED	Ei 	0 	 	 	 	 	 	 	 	
 	uploadrequest_date 	t
	*/
	
	if ($count > 0)
	{
		page_err("Upload request with the exact same name of '" . $name . "' already exists! Are you sure you didn't push the button twice? Duplicates are bad mmkay.");
	}
	else
	{
		global $CURUSER;
		safequery("INSERT INTO uploadrequest (name, description, user_id, status, deleted, uploadrequest_date)" .
			" VALUES (" .
			sqlesc(trim($name)).
			", " . sqlesc($description).
			", " . $CURUSER["id"].
			", 'bad'".
			", 0".
			", NOW()".
			")"
			);
		$id = mysql_insert_id();
		foreach ($categories as $cat)
		{
			safequery("INSERT INTO uploadrequest_category (uploadrequest_id, category_id) VALUES($id, $cat)");
		}
		confirmation("Upload request was submitted with ID number $id.", "viewuploadrequest.php?id=" . $id, "Upload Request accepted", 3);
	}
}
?>

<center>
<table width="90%"><tr><td>
<form action="uploadrequest.php" method="post">
Request name<br>
(i.e. "New scifi movies with finnish subtitles")<br>
<br>
<input class="input" type="text" name="name" size="40" value="<?=htmlspecialchars($name)?>" /><br>
<br>
Description (optional) (<a href="bbcode.html">BBCode</a> allowed)<br>
(more detailed description of your request, if necessary)<br>
<br>
<textarea class="input" name="description" rows="20" cols="80"><?=$description?></textarea><br>
<br>
Torrent categories (used by the automatic match search functionality)<br>
<font size="1">
	Categories that will be required for possible upload request matches. Matches are checked for automatically and only 
	torrents that have ALL the specified categories will be matched, so don't be too specific - i.e. if you don't really need subtitles, don't add the subtitle category because 
	that would hide ALL the torrents from you that do not have subtitles (even if other categories matched).<br>
</font>
<br>
<?php

show_category_choices($categories, $max_categories + 1, 4);

?>
<br>
<br>
<input class="input" type="submit" value="Submit upload request" />
</form>
</td></tr></table></center>
<?php

stdfoot();

?>
